package com.las2witsml;

//import classes
import javax.swing.table.TableCellRenderer;
import javax.swing.DefaultCellEditor;
import javax.swing.JRadioButton;
import javax.swing.JTable;
import javax.swing.UIManager;

import java.awt.Component;
/**
 * Title: ButtonRenderer.java
 * Description:  This class implements the TableCellRenderer interface and defines the method required by any object that would like to be a renderer for cells in a JTable
 * Copyright: Copyright (c) 2006
 * Company: Satyam Computer Services Ltd.
  * @version 1.0
 * @author Ravi Domakonda, Lalitha Yengaldas
 */

public class ButtonRenderer extends JRadioButton implements TableCellRenderer {
	/** 
	*  Constructor ButtonRenderer
	*/
	public ButtonRenderer() {
		setOpaque(true);
	}
	
	/**
	* Method getTableCellRendererComponent
	*This method returns the component used for drawing the cell. This method is used to configure the renderer appropriately before drawing. 
	*
	* @param table
	* @param value
	* @param isSelected
	* @param hasFocus
	* @param row
	* @param column
	* @return Component
	*
	*/
	public Component getTableCellRendererComponent(JTable table, Object value,
		   boolean isSelected, boolean hasFocus, int row, int column) {
		if (isSelected) {
			setForeground(table.getSelectionForeground());
			setBackground(table.getSelectionBackground());
		} else{
			setForeground(table.getForeground());
			setBackground(UIManager.getColor("JRadioButton.background"));
		}
		setText( (value ==null) ? "" : value.toString() );
		return this;
	}
}
