package com.las2witsml;

//import classes
//import swing classes
import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JTable;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JComboBox;
import javax.swing.JScrollPane;
import javax.swing.JOptionPane;
import javax.swing .ImageIcon;

import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableCellEditor;
import javax.swing.table.TableColumn;
import javax.swing.table.JTableHeader;

import javax.swing.event .TableModelListener;
import javax.swing.event .TableModelEvent;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionListener;
import javax.swing.event.ListSelectionEvent;
 
 
import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.FlowLayout;
import java.awt.Dimension;
import java.awt.Container;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;
import java.awt.Cursor;
import java.awt.Color;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.File;

import java.util.Vector;
import java.util.Hashtable;
import java.util.Enumeration;
import java.util.Timer;
import java.util.ArrayList;

import javax.swing.ActionMap;
import javax.swing.InputMap;
import javax.swing.AbstractAction;
import javax.swing.JRootPane;
import javax.swing.KeyStroke;


/**
 * Title: ConversionCustomizeMapping.java
 * Description:  This class is used to display Default Mappings as well as mappings changed in FileSelection
 * Copyright: Copyright (c) 2006
 * Company: Satyam Computer Services Ltd.
  * @version 1.0
 * @author Ravi Domakonda, Lalitha Yengaldas
 */
public class ConversionCustomizeMapping extends JDialog implements ActionListener
{
MappingReader mappingReader=null;
JButton btnSave=null;
JButton btnClose=null;
JComboBox cmbLAS=null;
Hashtable htCustomizeWells=null;
Hashtable htCustomizeWellLogs=null;
LasWitsml laswitsml;
Container c ;
JTable jtCustomize;
JComboBox cmbWitsml=null;
JComboBox cmbWitsmlLogs=null;
JPanel  pnCustomize=null,pnButton=null;
String[] strCustomizeHeader= {"LAS Name","WITSML Element"};
DefaultTableModel dmCustomize;
JScrollPane scrollPane=null;
ArrayList arLASElements=null;
ArrayList arWITSMLElements=null;
String LASElement=null;
String WITSMLElement=null;
Hashtable htTableElements=null;
LasDataFile objLasDataFile=null;
String strMappingFileName=null;
String strFoundDifference="N";
String strCustomizeFileName=null;
ConversionCustomizeMapping(LasWitsml objLasWitsml,String strTitle)
	{
	super(objLasWitsml,strTitle,true);
	try{
	JRootPane rootPane = this.getRootPane();
			InputMap iMap = rootPane.getInputMap(
			JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT);
			iMap.put(KeyStroke.getKeyStroke(KeyEvent.VK_ESCAPE, 0), "escape");
			
			ActionMap aMap = rootPane.getActionMap();
			aMap.put("escape", new AbstractAction() {
				public void actionPerformed(ActionEvent e) {
					dispose();
				}
			});
	this.laswitsml = objLasWitsml;
	c = getContentPane();
	File fCurrentPath = new File(".");
	String strPath  = new File(fCurrentPath.getCanonicalPath()).getParent();
	String strImagePath=strPath+"/images/";
	mappingReader=new MappingReader();
	htCustomizeWells=new Hashtable();
	htCustomizeWellLogs=new Hashtable();
	c.setLayout(new BorderLayout());
	pnCustomize=new JPanel();
	pnCustomize.setLayout(new GridLayout(1,2));
	pnButton=new JPanel();
	pnButton.setLayout(new FlowLayout());
	btnSave=new JButton();
	btnSave.setIcon(new ImageIcon(strImagePath+"save.gif"));
	btnSave.setToolTipText("Save");
	btnSave.setBorder(null);
	btnClose=new JButton();
	btnClose.setIcon(new ImageIcon(strImagePath+"cancel.gif"));
	btnClose.setToolTipText("cancel");
	btnClose.setBorder(null);
	pnButton.add(btnSave);
	pnButton.add(btnClose);
	pnButton.setBackground(Color.white);
	btnClose.addActionListener(this);
	btnSave.addActionListener(this);
	btnSave.setMnemonic('S');
	btnClose.setMnemonic('C');
	//System.out.println("The mapping in ConversionCustomizemapping from lasdatafile  " + laswitsml.objLasDataFile.getMappingFile());
	strCustomizeFileName  =  laswitsml.objLasDataFile.getMappingFile();
	
	//System.out.println("The Full Path name in conversion customize mapping is :::::::::::::::::: " + strCustomizeFileName);
	
	htTableElements=new Hashtable();
	
	//create default table model
	dmCustomize = new DefaultTableModel(strCustomizeHeader,0);
	
	//add table listener
	//dmCustomize.addTableModelListener(this);
	
	//create a table with the above default table model
	jtCustomize = new JTable(dmCustomize){
		//disable cell editing
			public boolean isCellEditable(int rowIndex, int vColIndex) {
			if (vColIndex == 1) {
				return true;
			} else {
				return false;
			}
		}
		
		public TableCellRenderer getCellRenderer(int row, int column) {
			TableColumn tableColumn = getColumnModel().getColumn(column);
			TableCellRenderer renderer = tableColumn.getCellRenderer();
			if (renderer == null) {
				Class c = getColumnClass(column);
				if( c.equals(Object.class) ) {
					Object o = getValueAt(row,column);
					if(o instanceof JComboBox){
					}
					if( o != null )
						c = getValueAt(row,column).getClass();
				}
				renderer = getDefaultRenderer(c);
			}
			return renderer;
		}
		
		public TableCellEditor getCellEditor(int row, int column) {
			TableColumn tableColumn = getColumnModel().getColumn(column);
			TableCellEditor editor = tableColumn.getCellEditor();
			if (editor == null) {
				Class c = getColumnClass(column);
				if( c.equals(Object.class) ) {
					Object o = getValueAt(row,column);
					if( o != null )
						c = getValueAt(row,column).getClass();
				}
				editor = getDefaultEditor(c);
			}
			return editor;
		}
		};
		
		
		jtCustomize.setDefaultRenderer( JComponent.class, new JComponentCellRenderer());
		jtCustomize.setDefaultEditor( JComponent.class, new JComponentCellEditor());
		
		/*jtCustomize.setDefaultRenderer( JComponent.class, new MyComboBoxRenderer());
		jtCustomize.setDefaultEditor( JComponent.class, new MyComboBoxEditor());*/
		
		//set font, fore ground color and back ground color of jtCurrentTable header
		JTableHeader anHeader = jtCustomize.getTableHeader();
		anHeader.setForeground(Color.blue);
		//anHeader.setFont(fnHdrFont);
		anHeader.setBackground(new Color(255,204,153));
		
		//set the Row Height
		jtCustomize.setRowHeight(20);	
		
		 //add jtCurrentTable to scroll pane
		scrollPane = new JScrollPane(jtCustomize);
		jtCustomize.setPreferredScrollableViewportSize(new Dimension(400, 200));
		c.add(scrollPane,BorderLayout.CENTER);
		
		htCustomizeWells = mappingReader.LASWITSMLElements("wells",strCustomizeFileName);
		htCustomizeWellLogs = mappingReader.LASWITSMLElements("wellLogs",strCustomizeFileName);
		
		Enumeration e = htCustomizeWells.keys(); 
		Enumeration e1 = htCustomizeWellLogs.keys(); 
		
		
		arLASElements=new ArrayList();
		arWITSMLElements=new ArrayList();
		int i=1;
		while(e.hasMoreElements() ) { 
			String strWitsmlElement="";
			String strLasElement="";
			strLasElement = (String)e.nextElement();
			//strWitsmlElement=(String) htCustomizeWells.get(strLasElement); 
			//getting the list of Witsml for corresponding LasElement
			ArrayList alList=(ArrayList) htCustomizeWells.get(strLasElement); 
			String[] strCustomizeData= {strLasElement,""};
			dmCustomize.addRow(strCustomizeData);
			cmbWitsml=new JComboBox();
			for(int k=0;k<alList.size();k++){
			cmbWitsml.addItem(alList.get(k));
			arWITSMLElements.add(alList.get(k));
			}
			//cmbWitsml.setLightWeightPopupEnabled(true);
			//cmbWitsml.setEditable(true);
			jtCustomize.setValueAt( cmbWitsml, (i-1), 1 );
			i++;
		}
		//System.out.println("The i value is " + i);
		while(e1.hasMoreElements() ) { 
			String strWitsmlElement="";
			String strLasElement="";
			strLasElement = (String)e1.nextElement();
			//strWitsmlElement=(String) htCustomizeWellLogs.get(strLasElement); 
			ArrayList alList=(ArrayList) htCustomizeWellLogs.get(strLasElement); 
			String[] strCustomizeData= {strLasElement,""};
			dmCustomize.addRow(strCustomizeData);
			cmbWitsmlLogs=new JComboBox();
			//cmbWitsmlLogs.setEditable(true);
			for(int k=0;k<alList.size();k++){
			cmbWitsmlLogs.addItem(alList.get(k));
			arWITSMLElements.add(alList.get(k));
			}
			jtCustomize.setValueAt( cmbWitsmlLogs, (i-1), 1 );
			i++;
		}
		
		      
		//System.out.println("The Arraylist of WITSML Elements is " + arWITSMLElements.size());
		
		c.add(pnButton,BorderLayout.SOUTH);
		
		//System.out.println("The Row count is " +jtCustomize.getRowCount());
		//System.out.println("The Row count is " +jtCustomize.getColumnCount());
					
		}catch(Exception e)
		{
			System.out.println("The exception is " + e);
		}		
	}
	
	public void actionPerformed(ActionEvent ae)
	{
		String strMappingFile=strCustomizeFileName;
		//System.out.println("The strMappingFile is >>>>>>>>>>>>>> " + strMappingFile);
		if(ae.getSource() == btnSave)
		{
			try{
				File f=new File(".");
				String strPath=new File(f.getCanonicalPath()).getParent();
				//System.out.println("The strpath is >>>>>>>>>>>>>> " + strPath);
				/*String strMappingFile=strCustomizeFileName;
				System.out.println("The strMappingFile is >>>>>>>>>>>>>> " + strMappingFile);*/
				
				String str="selectedItemReminder";
					for(int rowCount=0;rowCount<jtCustomize.getRowCount();rowCount++)
					{
						for(int columnCount=0;columnCount<jtCustomize.getColumnCount();columnCount++)
							{
								if(columnCount == 0){
								LASElement = jtCustomize.getValueAt(rowCount,columnCount).toString();
								//System.out.println("The LAS Element is " + LASElement);
								}else{
								Object o=jtCustomize.getValueAt(rowCount,columnCount);
								WITSMLElement=o.toString().substring((o.toString().indexOf("selectedItemReminder")+str.length()+1),(o.toString().length()-1));
								//System.out.println("The WITSML Element is " +WITSMLElement);
								//System.out.println("The WITSML from arraylist is " +arWITSMLElements.get(rowCount));
									if(!WITSMLElement.trim().equalsIgnoreCase(arWITSMLElements.get(rowCount).toString().trim()))
									{
										//System.out.println("Found difference");
										strFoundDifference="Y";
									}
								//System.out.println("The WITSML Element is " + jtCustomize.getCellRenderer(rowCount,columnCount).getTableCellRendererComponent(jtCustomize,null,false,false,rowCount,columnCount));
								}
							}		
								htTableElements.put(LASElement,WITSMLElement);
					}
				if(strFoundDifference.trim().equalsIgnoreCase("Y")){
					String strInputFileName = JOptionPane.showInputDialog("Please enter Mapping name"); 
					if(strInputFileName!=null && strInputFileName.equals("null") == false && strInputFileName.equals("") == false)
					{
					FileInputStream fis=new FileInputStream(strMappingFile);
					byte[] buf=new byte[fis.available()];
					fis.read(buf,0,buf.length);
					String strFileData=new String(buf);
					strMappingFileName=strPath+"/mappings/"+strInputFileName+".xml";
					setMappingFile(strMappingFileName);
					FileOutputStream fos=new FileOutputStream(strMappingFileName);
					byte[] writeBuf=strFileData.getBytes();
					fos.write(writeBuf,0,writeBuf.length);
					mappingReader.UpdateWITSMLElements(strMappingFileName,htTableElements);
					JOptionPane.showMessageDialog(null, "Mapping file is saved ", "LAS to WITSML Conversion", JOptionPane.INFORMATION_MESSAGE); 	
					dispose();
					//mappingReader.UpdateWITSMLElements(strMappingFileName,htTableElements);
					}else{
						//System.out.println("The file name is not entered");
						strMappingFileName=strMappingFile;
						setMappingFile(strMappingFileName);
						dispose();
					}
				}else{
					JOptionPane.showMessageDialog(null, "No mappings are changed, Previous mappings will be applied ", "LAS to WITSML Conversion", JOptionPane.INFORMATION_MESSAGE); 	
					strMappingFileName=strMappingFile;
					setMappingFile(strMappingFileName);
					dispose();
					}
			}catch(Exception e)
			{
				System.out.println(e.getMessage());
			}
		}
		else if(ae.getSource() == btnClose)
		{
			//setting previous mappings if any after clicking Close button
			strMappingFileName=strMappingFile;
			setMappingFile(strMappingFileName);
			dispose();
			//dispose();
		}
	}
	
	/**
	* Method setMappingFile
	* This method will set the mapping file to be used for conversion
	* @param strMappingFileName Mapping File to be used for conversion
	*
	*/
	public void setMappingFile(String strMappingFileName)
	{
		this.strMappingFileName=strMappingFileName;
	}
	/**
	* Method getMappingFile
	* This method returns the mapping file to be used for conversion
	* @return strMappingFile
	*
	*/
	public String getMappingFile()
	{
		return strMappingFileName;
	}
} 
