package com.las2witsml;

//import swing classes
import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JTable;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JComboBox;
import javax.swing.JScrollPane;
import javax.swing.JOptionPane;
import javax.swing .ImageIcon;

import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableCellEditor;
import javax.swing.table.TableColumn;
import javax.swing.table.JTableHeader;

import javax.swing.event .TableModelListener;
import javax.swing.event .TableModelEvent;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionListener;
import javax.swing.event.ListSelectionEvent;
 
 
import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.FlowLayout;
import java.awt.Dimension;
import java.awt.Container;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;
import java.awt.Cursor;
import java.awt.Color;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.File;

import java.util.Vector;
import java.util.Hashtable;
import java.util.Enumeration;
import java.util.Timer;
import java.util.ArrayList;

import javax.swing.ActionMap;
import javax.swing.InputMap;
import javax.swing.AbstractAction;
import javax.swing.JRootPane;
import javax.swing.KeyStroke;

/**
 * Title: CustomizeMapping.java
 * Description:  This class is used to get the Default mappings and make save the selected mappings
 * Copyright: Copyright (c) 2006
 * Company: Satyam Computer Services Ltd.
  * @version 1.0
 * @author Ravi Domakonda, Lalitha Yengaldas
 */


public class CustomizeMapping extends JDialog implements ActionListener,TableModelListener {
	MappingReader mappingReader=null;
	JButton btnSave=null;
	JButton btnClose=null;
	JComboBox cmbLAS=null;
	Hashtable htCustomizeWells=null;
	Hashtable htCustomizeWellLogs=null;
	LasWitsml laswitsml;
	Container c ;
	JTable jtCustomize;
	JComboBox cmbWitsml=null;
	JComboBox cmbWitsmlLogs=null;
	JPanel  pnCustomize=null,pnButton=null;
	String[] strCustomizeHeader= {"LAS Name","WITSML Element"};
	DefaultTableModel dmCustomize;
	JScrollPane scrollPane=null;
	ArrayList arLASElements=null;
	ArrayList arWITSMLElements=null;
	String LASElement=null;
	String WITSMLElement=null;
	Hashtable htTableElements=null;
	Hashtable htChangedElements=null;
	LasDataFile objLasDataFile=null;
	String strMappingFileName=null;
	String strFoundDifference="N";
	String strCustomizeFileName=null;

	/** 
	*  Constructor CustomizeMapping
	*/
	public CustomizeMapping(LasWitsml objLasWitsml,String strTitle) {
		super(objLasWitsml,strTitle,true);
		try{
			
			JRootPane rootPane = this.getRootPane();
			InputMap iMap = rootPane.getInputMap(
			JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT);
			iMap.put(KeyStroke.getKeyStroke(KeyEvent.VK_ESCAPE, 0), "escape");
			
			ActionMap aMap = rootPane.getActionMap();
			aMap.put("escape", new AbstractAction() {
				public void actionPerformed(ActionEvent e) {
					dispose();
				}
			});
		
			this.laswitsml=objLasWitsml;
			c = getContentPane();
			File fCurrentPath = new File(".");
			String strPath  = new File(fCurrentPath.getCanonicalPath()).getParent();
			String strImagePath=strPath+"/images/";
			mappingReader=new MappingReader();
			htCustomizeWells=new Hashtable();
			htCustomizeWellLogs=new Hashtable();
			c.setLayout(new BorderLayout());
			pnCustomize=new JPanel();
			pnCustomize.setLayout(new GridLayout(1,2));
			pnButton=new JPanel();
			pnButton.setLayout(new FlowLayout());
			btnSave=new JButton();
			btnSave.setIcon(new ImageIcon(strImagePath+"save.gif"));
			btnSave.setToolTipText("Save");
			btnSave.setBorder(null);
			btnClose=new JButton();
			btnClose.setIcon(new ImageIcon(strImagePath+"cancel.gif"));
			btnClose.setToolTipText("cancel");
			btnClose.setBorder(null);
			pnButton.add(btnSave);
			pnButton.add(btnClose);
			pnButton.setBackground(Color.white);
			btnClose.addActionListener(this);
			btnSave.addActionListener(this);
			btnSave.setMnemonic('S');
			btnClose.setMnemonic('C');
			htTableElements=new Hashtable();
			htChangedElements=new Hashtable();
			//create default table model
			dmCustomize = new DefaultTableModel(strCustomizeHeader,0);
			//add table listener
			dmCustomize.addTableModelListener(this);
			//create a table with the above default table model
			jtCustomize = new JTable(dmCustomize){
			//disable cell editing
			public boolean isCellEditable(int rowIndex, int vColIndex) {
				if (vColIndex == 1) {
					return true;
				} else {
					return false;
				}
			}
				
			public TableCellRenderer getCellRenderer(int row, int column) {
				TableColumn tableColumn = getColumnModel().getColumn(column);
				TableCellRenderer renderer = tableColumn.getCellRenderer();
				if (renderer == null) {
					Class c = getColumnClass(column);
					if( c.equals(Object.class) ) {
						Object o = getValueAt(row,column);
						if(o instanceof JComboBox){
						}
						if( o != null )
							c = getValueAt(row,column).getClass();
					}
					renderer = getDefaultRenderer(c);
				}
				return renderer;
			}
				
				public TableCellEditor getCellEditor(int row, int column) {
					TableColumn tableColumn = getColumnModel().getColumn(column);
					TableCellEditor editor = tableColumn.getCellEditor();
					if (editor == null) {
						Class c = getColumnClass(column);
						if( c.equals(Object.class) ) {
							Object o = getValueAt(row,column);
							if( o != null )
								c = getValueAt(row,column).getClass();
						}
						editor = getDefaultEditor(c);
					}
					return editor;
				}
				};
				
			
			jtCustomize.setDefaultRenderer( JComponent.class, new JComponentCellRenderer());
			jtCustomize.setDefaultEditor( JComponent.class, new JComponentCellEditor());
			
			//set font, fore ground color and back ground color of jtCurrentTable header
			JTableHeader anHeader = jtCustomize.getTableHeader();
			anHeader.setForeground(Color.blue);
			//anHeader.setFont(fnHdrFont);
			anHeader.setBackground(new Color(255,204,153));
			
			//set the Row Height
			jtCustomize.setRowHeight(20);	
			
			//add jtCurrentTable to scroll pane
			scrollPane = new JScrollPane(jtCustomize);
			jtCustomize.setPreferredScrollableViewportSize(new Dimension(400, 200));
			c.add(scrollPane,BorderLayout.CENTER);
			
			//if strCustomizeFileName is null. we are coming first time. If it is not null then we are getting the required filename from laswitsml.objLasDataFile.getMappingFile();
			strCustomizeFileName  =  laswitsml.objLasDataFile.getMappingFile();
			//System.out.println("The customizing filename is PPPPPPPPPPPPPPPPPPPP  " + strCustomizeFileName);
			
			htCustomizeWells = mappingReader.LASWITSMLElements("wells",strCustomizeFileName);
			htCustomizeWellLogs = mappingReader.LASWITSMLElements("wellLogs",strCustomizeFileName);
			
			Enumeration e = htCustomizeWells.keys(); 
			Enumeration e1 = htCustomizeWellLogs.keys(); 
			
			arLASElements=new ArrayList();
			arWITSMLElements=new ArrayList();
			int i=1;
			while(e.hasMoreElements() ) { 
				String strWitsmlElement="";
				String strLasElement="";
				strLasElement = (String)e.nextElement();
				//getting the list of Witsml for corresponding LasElement
				ArrayList alList=(ArrayList) htCustomizeWells.get(strLasElement); 
				String[] strCustomizeData= {strLasElement,""};
				dmCustomize.addRow(strCustomizeData);
				cmbWitsml=new JComboBox();
				for(int k=0;k<alList.size();k++){
				cmbWitsml.addItem(alList.get(k));
				arWITSMLElements.add(alList.get(k));
				}
			
				//added below code as per paul TestResults on 23/06/2006
				//cmbWitsml.setEditable(true);
				cmbWitsml.setEditable(false);
				
				jtCustomize.setValueAt( cmbWitsml, (i-1), 1 );
				i++;
			}
			
			while(e1.hasMoreElements() ) { 
				String strWitsmlElement="";
				String strLasElement="";
				strLasElement = (String)e1.nextElement();
				//strWitsmlElement=(String) htCustomizeWellLogs.get(strLasElement); 
				ArrayList alList=(ArrayList) htCustomizeWellLogs.get(strLasElement); 
				String[] strCustomizeData= {strLasElement,""};
				dmCustomize.addRow(strCustomizeData);
				cmbWitsmlLogs=new JComboBox();
				//cmbWitsmlLogs.setEditable(true);
				cmbWitsmlLogs.setEditable(false);
				for(int k=0;k<alList.size();k++){
					cmbWitsmlLogs.addItem(alList.get(k));
					//System.out.println("In well logs is  >>>>>>>> strLasElement " + strLasElement +":: witsml "+ alList.get(k));
					arWITSMLElements.add(alList.get(k));
				}
				jtCustomize.setValueAt( cmbWitsmlLogs, (i-1), 1 );
				i++;
			}
			
			      
			//System.out.println("The Arraylist of WITSML Elements is " + arWITSMLElements.size());
			
			c.add(pnButton,BorderLayout.SOUTH);
			
			//System.out.println("The Row count is " +jtCustomize.getRowCount());
			//System.out.println("The Row count is " +jtCustomize.getColumnCount());
		} catch (Exception e)
		{
			System.out.println("The error is " + e);
		}
		
	}
	
	public void actionPerformed(ActionEvent ae) 	{
		if(ae.getSource() == btnSave)
		{
			try{
			String strInputFileName=null;
				File f=new File(".");
				String strPath=new File(f.getCanonicalPath()).getParent();
				//System.out.println("The strpath is >>>>>>>>>>>>>> " + strPath);
				String strMappingFile=strPath+"/mappings/Default.xml";
				//System.out.println("The strMappingFile is >>>>>>>>>>>>>> " + strMappingFile);
								
				String str="selectedItemReminder";
					for(int rowCount=0;rowCount<jtCustomize.getRowCount();rowCount++)
					{
						for(int columnCount=0;columnCount<jtCustomize.getColumnCount();columnCount++)
							{
								if(columnCount == 0){
								LASElement = jtCustomize.getValueAt(rowCount,columnCount).toString();
								//System.out.println("The LAS Element is " + LASElement);
								}else{
								Object o=jtCustomize.getValueAt(rowCount,columnCount);
								WITSMLElement=o.toString().substring((o.toString().indexOf("selectedItemReminder")+str.length()+1),(o.toString().length()-1));
								//System.out.println("The WITSML Element is   ::"+WITSMLElement);
								//System.out.println("The WITSML from arraylist is " +arWITSMLElements.get(rowCount));
								
									if(!WITSMLElement.trim().equalsIgnoreCase(arWITSMLElements.get(rowCount).toString().trim()))
										{
											//System.out.println("The changed Witsml element is " + WITSMLElement + " and corresponding LAS is " + LASElement);				
											//System.out.println("Found difference");
											strFoundDifference="Y";
											//htChangedElements.put(LASElement,WITSMLElement);
										}
									//System.out.println("The WITSML Element is " + jtCustomize.getCellRenderer(rowCount,columnCount).getTableCellRendererComponent(jtCustomize,null,false,false,rowCount,columnCount));
								}
							}		
								htTableElements.put(LASElement,WITSMLElement);
					}
					//System.out.println("The size of htChanged Elements are {{{{{ " + htChangedElements.size());
				if(strFoundDifference.trim().equalsIgnoreCase("Y")){
					strInputFileName = JOptionPane.showInputDialog("Please enter Mapping name"); 
					//strInputFileName = fnAlert();
					if(strInputFileName!=null && strInputFileName.equals("null") == false && strInputFileName.equals("") == false) {
						strInputFileName = strInputFileName.trim();
						if (strInputFileName.equals("")) {
							JOptionPane.showMessageDialog(null, "Enter a file name for saving mappings ", "LAS to WITSML Conversion", JOptionPane.ERROR_MESSAGE); 	
							return;
						} else {
							FileInputStream fis=new FileInputStream(strMappingFile);
							byte[] buf=new byte[fis.available()];
							fis.read(buf,0,buf.length);
							String strFileData=new String(buf);
							strMappingFileName=strPath+"/mappings/"+strInputFileName+".xml";
							setMappingFile(strMappingFileName);
							FileOutputStream fos=new FileOutputStream(strMappingFileName);
							byte[] writeBuf=strFileData.getBytes();
							fos.write(writeBuf,0,writeBuf.length);
							mappingReader.UpdateWITSMLElements(strMappingFileName,htTableElements);
							JOptionPane.showMessageDialog(null, "Mapping file is saved ", "LAS to WITSML Conversion", JOptionPane.INFORMATION_MESSAGE); 	
							dispose();
						}
					}else{
						System.out.println("The file name is not entered");
						JOptionPane.showMessageDialog(null, "No mappings name is entered, Default mappings will be applied ", "LAS to WITSML Conversion", JOptionPane.INFORMATION_MESSAGE);
//JOptionPane.showMessageDialog(null, "Please enter the mapping name", "LAS to WITSML Conversion", JOptionPane.INFORMATION_MESSAGE);
						//strInputFileName = fnAlert(); 							
						strMappingFileName=strMappingFile;
						setMappingFile(strMappingFileName);
						dispose();
					}
				}else{
					JOptionPane.showMessageDialog(null, "No mappings are changed, Default mappings will be applied ", "LAS to WITSML Conversion", JOptionPane.INFORMATION_MESSAGE); 	
					strMappingFileName=strMappingFile;
					setMappingFile(strMappingFileName);
					dispose();
					}
			}catch(Exception e)
			{
				System.out.println(e.getMessage());
			}
		}
		else if(ae.getSource() == btnClose)
		{
			//dispose();
			//setting previous mappings if any after clicking Close button
			//strMappingFileName=strMappingFile;
			setMappingFile(strCustomizeFileName);
			dispose();
			//dispose();
		}
	}
	
	//added by ravi for deselecting the checkboxs for curveSelection on 04/02/2006
	public void tableChanged(TableModelEvent e) { 
	      /*if (e.getType() == TableModelEvent.UPDATE) { 
		//System.out.println("The table changed");
		} */
	}
	
	/**
	* Method setMappingFile
	* This method will set the mapping file to be used for conversion
	* @param strMappingFileName Mapping File to be used for conversion
	*
	*/
	public void setMappingFile(String strMappingFileName)
	{
		this.strMappingFileName=strMappingFileName;
	}
	/**
	* Method getMappingFile
	* This method returns the mapping file to be used for conversion
	* @return strMappingFile
	*
	*/
	public String getMappingFile()
	{
		return strMappingFileName;
	}
	
	/**
	* Method setChangedMappings
	* This method will set the changed mapping file to be used for conversion
	* @param htChangedElements Hashtable used for changing the Elements from default
	*
	*/
	public void setChangedMappings(Hashtable htChangedElements){
		this.htChangedElements=htChangedElements;
	}
	/**
	* Method getChangedMappings
	* This method returns the mapping file to be used for conversion
	* @return strMappingFile
	*
	*/
	public Hashtable getChangedMappings() {
		//check for the section and get the mappings
		return htChangedElements;
	}
	
	public String fnAlert()
	{
	String strInputFileName = JOptionPane.showInputDialog("Please enter Mapping name"); 
	return strInputFileName;
	}
} 
