package com.las2witsml;

//import package
import java.util.Hashtable;

/**
 * Title: LasParameterData.java
 * Description: This class holds parameter selection details
 * Copyright: Copyright (c) 2006
 * Company: Satyam Computer Services Ltd.
 * @author Ravi Domakonda, Lalitha Yengaldas
 * @version 1.0
 */
 
public class LasParameterData {
	//to hold well section data
	private Hashtable htWellSectionData;
	//to hold run parameter section data
	private Hashtable htRunParameterSectionData;
	//to hold curve section  and run parameter data
	private Hashtable htParameterSectionData;
	//to hold curve section data
	private Hashtable htCurveSectionData;
	//to hold LasSectionInfo object
	private  LasSectionInfo objLasSectionInfo;

	/** 
	*  Constructor LasParameterData
	*/
	public LasParameterData() {
		htWellSectionData = new Hashtable();
		htRunParameterSectionData = new Hashtable();
		htParameterSectionData = new Hashtable();
		htCurveSectionData = new Hashtable();
	}	
	
  /**
	 * Method setWellSectionData
	 *This method sets the Object of WellSection Data.
	 * @param objLasSectionInfo
	 *
	 */
	public void setWellSectionData(LasSectionInfo objLasSectionInfo)
	{
		if (objLasSectionInfo != null ) {
			this.htWellSectionData.put(objLasSectionInfo.getMnemonic(),objLasSectionInfo);
		}
	}
	/**
	 * Method getWellSectionData
	 *This method returns Hashtable of WellSectionData.
	 * @return Hashtable
	 *
	 */
	public Hashtable getWellSectionData()
	{
		return htWellSectionData;
	}
	
	/**
	 * Method setRunParameterSectionData
	 *This method sets the Object of RunParameterSectionData
	 * @param objLasSectionInfo
	 *
	 */
	public void setRunParameterSectionData(LasSectionInfo objLasSectionInfo)
	{
		if (objLasSectionInfo != null ) {
			this.htRunParameterSectionData.put(objLasSectionInfo.getMnemonic(),objLasSectionInfo);
		}
	}
	/**
	 * Method getRunParameterSectionData
	 *This method returns Hashtable of RunParameterSectionData
	 * @return Hashtable
	 *
	 */
	public Hashtable getRunParameterSectionData()
	{
		return htRunParameterSectionData;
	}
	
  	/**
	 * Method setParameterSectionData
	 *This method sets the Object of ParameterSectionData
	 * @param objLasSectionInfo
	 *
	 */
	public void setParameterSectionData(LasSectionInfo objLasSectionInfo)
	{
		if (objLasSectionInfo != null ) {
			this.htParameterSectionData.put(objLasSectionInfo.getMnemonic(),objLasSectionInfo);
		}
	}
	/**
	 * Method getParameterSectionData
	 *This method returns Hashtable of ParameterSectionData
	 * @return Hashtable
	 *
	 */
	public Hashtable getParameterSectionData()
	{
		return htParameterSectionData;
	}
	
	/**
	 * Method setCurveSectionData
	 *This method sets the Object of CurveSectionData
	 * @param objLasSectionInfo
	 *
	 */
	public void setCurveSectionData(LasSectionInfo objLasSectionInfo)
	{
		if (objLasSectionInfo != null ) {
			this.htCurveSectionData.put(objLasSectionInfo.getMnemonic(),objLasSectionInfo);
		}
	}
	/**
	 * Method getCurveSectionData
	 *This method returns Hashtable of CurveSectionData
	 * @return Hashtable
	 *
	 */
	public Hashtable getCurveSectionData()
	{
		return htCurveSectionData;
	}
	
	
}

