package com.las2witsml;

/**
 * Title: LasSectionInfo.java
 * Description:  This class store the LAS information as a line 
 * Copyright: Copyright (c) 2006
 * Company: Satyam Computer Services Ltd.
  * @version 1.0
 * @author Ravi Domakonda, Lalitha Yengaldas
 */
public class LasSectionInfo {
	//declare variables
	private Boolean blnIsSelected;
	private String strMnemonic;
	private String strUnit;
	private String strValue;
	private String strDescription; 
	private String strFormat; 
	//variable to check mandatory data selected on UI
	private String strMandParameter="->Parameters";
	private String strMandCurveData="->Curve Data";
	/** 
	*  Constructor LasSectionInfo
	*/
  public LasSectionInfo() {
		blnIsSelected=new Boolean(true);
		strMnemonic = "";
		strUnit = "";
		strValue = "";
		strDescription = "";
	  }	
	/**
	 * Method setMnemonic
	 *This method sets the Mnemonic value of the LAS File
	 * @param mnemonic
	 *
	 */
	public void setMnemonic(String strMnemonic)
	{
		this.strMnemonic = strMnemonic;
	}

	/**
	 * Method getMnemonic
	 *This method returns String of Mnemonic of the LAS file
	 * @return String
	 *
	 */
	public String getMnemonic()
	{
		return strMnemonic;
	}
	
	/**
	 * Method setIsSelected
	 *This method sets the selected value of the LAS File
	 * @param selected
	 *
	 */
	public void setIsSelected(Boolean selected)
	{
		this.blnIsSelected = selected;
	}

	/**
	 * Method getIsSelected
	 **This method returns Boolean Value.
	 * @return Boolean
	 *
	 */
	public Boolean getIsSelected()
	{
		return blnIsSelected;
	}
	
	
	/**
	 * Method setUnit
	 *This method sets the unit value of the LAS File
	 * @param unit
	 *
	 */
	public void setUnit(String unit)
	{
		this.strUnit = unit;
	}

	/**
	 * Method getUnit
	 *This method returns Unit Value as a String.
	 * @return String
	 *
	 */
	public String getUnit()
	{
		return strUnit;
	}

	
	/**
	 * Method setValue
	 *This method sets the Value of the LAS File
	 * @param value
	 *
	 */
	public void setValue(String value)
	{
		this.strValue = value;
	}

	/**
	 * Method getValue
	 *This method returns Value as a String.
	 * @return String
	 *
	 */
	public String getValue()
	{
		return strValue;
	}
	
	/**
	 * Method setDescription
	 *This method sets the Description of the LAS File
	 * @param description
	 *
	 */
	public void setDescription(String description)
	{
		this.strDescription = description;
	}

	/**
	 * Method getDescription
	 *This method returns Description as a String
	 * @return String
	 *
	 */
	public String getDescription()
	{
		return strDescription;
	}

	/**
	 * Method setFormat
	 *This method sets the Format of the LAS File
	 * @param description
	 *
	 */
	public void setFormat(String format)
	{
		this.strFormat	= format;
	}

	/**
	 * Method getFormat
	 *This method returns Format as a String
	 * @return String
	 *
	 */
	public String getFormat()
	{
		return strFormat;
	}
	
	/**
	 * Method createRow
	 * This method creates a new row to  be displayed in a table on the user interface
	 * @param section to be displayed
	 * @param serial number to be displayed
	 * @param selected/unselected
	 *
	 */
	public Object[] createRow(String strSection, int intRowNum, boolean blnSelected)
	{
		Object[] newRow = new Object[5];
		
		if (strSection.equalsIgnoreCase(strMandParameter)) {
			//System.out.println(" in section "+strMandParameter);
			newRow[0] = new Boolean(blnSelected);
			newRow[1] = strMnemonic;
			if ((strMnemonic.equals("STRT")) || (strMnemonic.equals("STOP")) || (strMnemonic.equals("STEP")) || (strMnemonic.equals("NULL"))) {
				newRow[2] = strDescription+"  : "+strValue;
			} else {
				newRow[2] = strDescription;
			}
		} else if (strSection.equalsIgnoreCase(strMandCurveData)) {
			newRow[0] = new Boolean(blnSelected);
			//System.out.println("The Mnemonic value is >>>>>>>>>> " + strMnemonic);
			newRow[1] = strMnemonic;
			if (strMnemonic.equalsIgnoreCase("DEPT")) {
				if ((strDescription == null) || (strDescription.equals("") == true)) {
					strDescription = "DEPTH";
				}
			}
			if (strMnemonic.equalsIgnoreCase("TIME")) {
				if ((strDescription == null) || (strDescription.equals("") == true)) {
					strDescription = "TIME";
				}
			}
			
			newRow[2] = strDescription;		
			/* commented for interchanging API code and units
			newRow[3] = strValue;
			newRow[4] = strUnit;*/
			newRow[3] = strUnit;
			newRow[4] = strValue;
		}
		return newRow;
	}

} //end LasSectionInfo