package com.las2witsml;

//import classes
import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.FlowLayout;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Color;
import java.awt.Font;
import java.awt.Container;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JRadioButton;
import javax.swing.JCheckBox;
import javax.swing.JComponent;
import javax.swing.ListSelectionModel;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JTable;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import javax.swing.SwingUtilities;
import javax.swing.SwingConstants;
import javax.swing .ImageIcon;

import javax.swing.ActionMap;
import javax.swing.InputMap;
import javax.swing.AbstractAction;
import javax.swing.JRootPane;
import javax.swing.KeyStroke;


//table related classes
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableColumn;
import javax.swing.table.JTableHeader;

import java.io.File;
import java.io.IOException;
import java.util.Vector;
import java.util.ArrayList;

import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.DocumentBuilder;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.w3c.dom.Node;
import org.w3c.dom.Attr;
import org.w3c.dom.Text;
import org.apache.xpath.XPathAPI;
import org.apache.xpath.objects.XObject;

/**
 * Title: MappingSelector.java
 * Description:  This class displays all the available selections and allow the user to apply those selections 
 * Copyright: Copyright (c) 2006
 * Company: Satyam Computer Services Ltd.
  * @version 1.0
 * @author Ravi Domakonda, Lalitha Yengaldas
 */
public class MappingSelector extends JDialog implements ActionListener
{

	JButton btnApplySelection = null;
	JButton btnCancel = null;
	
	LasWitsml objLasWitsml;
	Container cContainer ;
	JTable jtLoadSelection;
	JPanel  pnLoadSelection = null, pnButton = null;
	
	String[] strSelectionHeader = {"S.No.","Selection File","Select"};
	DefaultTableModel dmLoadSelection;
	Color clActiveButton = new Color(255,255,201);
	
	JScrollPane scrollPane = null;
	
	String strSelectionFile = null;
	/** 
	*  Constructor MappingSelector
	*/
	public MappingSelector(LasWitsml objLasWitsml,String strTitle) 	{
		super(objLasWitsml,strTitle,true);
		
		try {
			
			this.objLasWitsml = objLasWitsml;
			
			JRootPane rootPane = this.getRootPane();
			InputMap iMap = rootPane.getInputMap(
			JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT);
			iMap.put(KeyStroke.getKeyStroke(KeyEvent.VK_ESCAPE, 0), "escape");
			
			ActionMap aMap = rootPane.getActionMap();
			aMap.put("escape", new AbstractAction() {
				public void actionPerformed(ActionEvent e) {
					dispose();
				}
			});

			//System.out.println("in MappingSelector");
			//get content pane
			cContainer = getContentPane();
			
			File fCurrentPath = new File(".");
			String strPath  = new File(fCurrentPath.getCanonicalPath()).getParent();
			String strImagePath=strPath+"/images/";
			
			Color clrHeaderBg = new Color(109,102,154);
			Font fnHdrFont = new Font("Arial",Font.BOLD,12);
			//Table header
			JLabel lblLoadSelection = new JLabel(" Available Selections ",SwingConstants.LEFT);
			lblLoadSelection.setForeground(Color.white);
			lblLoadSelection.setFont(fnHdrFont);
			
			cContainer.setLayout(new BorderLayout());
			//set panel properties
			pnLoadSelection = new JPanel();
			pnLoadSelection.setLayout(new GridLayout(1,1));
			pnLoadSelection.setBackground(clrHeaderBg);
			pnLoadSelection.add(lblLoadSelection);
			//add panel to container
			cContainer.add(pnLoadSelection,BorderLayout.NORTH);
			
			pnButton = new JPanel();
			pnButton.setLayout(new FlowLayout());
			//create buttons
			btnApplySelection = new JButton();
			btnApplySelection.setIcon(new ImageIcon(strImagePath+"apply_selection.gif"));
			btnApplySelection.setToolTipText("Apply Selection");
			btnApplySelection.setBorder(null);
			
			btnCancel = new JButton();
			btnCancel.setIcon(new ImageIcon(strImagePath+"cancel.gif"));
			btnCancel.setToolTipText("cancel");
			btnCancel.setBorder(null);
			
			//set shortcut keys for buttons
			btnApplySelection.setMnemonic('A');
			//btnCancel.setMnemonic('C');
			//add listener
			btnApplySelection.addActionListener(this);
			btnCancel.addActionListener(this);
			//add buttons to panel
			pnButton.add(btnApplySelection);
			pnButton.add(btnCancel);
			pnButton.setBackground(Color.white);
			//create table
			dmLoadSelection = new DefaultTableModel(strSelectionHeader,0);
			
			jtLoadSelection = new JTable(dmLoadSelection){
				/**
				* Method isCellEditable
				* This method asks the editor if it can start editing using anEvent
				* @return jcEditorComponent
				*
				*/
				public boolean isCellEditable(int rowIndex, int vColIndex) {
						if (vColIndex == 2) {
							return true;
						} else {
							//disable cell editing
							return false;
						}
				}
				public Component prepareRenderer(TableCellRenderer renderer, int rowIndex, int vColIndex) {
					Component c = super.prepareRenderer(renderer, rowIndex, vColIndex);
					if (c instanceof JComponent) {
						JComponent jc = (JComponent)c;
						if ((vColIndex == 1) || (vColIndex == 2))
							jc.setToolTipText((String)getValueAt(rowIndex, vColIndex));
					}
					if (isCellSelected(rowIndex, 3)) {
						//c.setBackground(Color.yellow);
						c.setBackground(clActiveButton);
						if (c instanceof JRadioButton) {
							JRadioButton jrb = (JRadioButton)c;
							jrb.setSelected(true);
						}
					} else {
						// If not shaded, match the table's background
						c.setBackground(getBackground());
						if (c instanceof JRadioButton) {
							JRadioButton jrb = (JRadioButton)c;
							jrb.setSelected(false);
						}
					}
					return c;
				}
			};
			//disable re-ordering of columns
			jtLoadSelection.getTableHeader().setReorderingAllowed(false);
			//set single row selection
			jtLoadSelection.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
			//enablee row selection 
			jtLoadSelection.setRowSelectionAllowed(true);
			
			JTableHeader anHeader = jtLoadSelection.getTableHeader();
			anHeader.setForeground(Color.blue);
			anHeader.setFont(fnHdrFont);
			anHeader.setBackground(new Color(255,204,153));
			
			jtLoadSelection.getColumn("Select").setCellRenderer(new ButtonRenderer());
			jtLoadSelection.getColumn("Select").setCellEditor(new ButtonEditor(new JCheckBox()));

			TableColumn tcSnCol = jtLoadSelection.getColumnModel().getColumn(0);//<-----------------
			TableColumn tcSelectCol = jtLoadSelection.getColumnModel().getColumn(2);//<-----------------
			
			int intSnColWidth=40;
							
			//set SN column width
			tcSnCol.setMinWidth(intSnColWidth);
			tcSnCol.setMaxWidth(intSnColWidth);
			tcSnCol.setPreferredWidth(intSnColWidth);
			
			//set Select column width
			/*tcSelectCol.setMinWidth(intSnColWidth);
			tcSelectCol.setMaxWidth(intSnColWidth);
			tcSelectCol.setPreferredWidth(intSnColWidth);*/
			scrollPane = new JScrollPane(jtLoadSelection);
			scrollPane.getViewport().setBackground(new Color(246, 231, 215));
			jtLoadSelection.setPreferredScrollableViewportSize(new Dimension(400, 200));
			cContainer.add(scrollPane,BorderLayout.CENTER);
			cContainer.add(pnButton,BorderLayout.SOUTH);
		} catch (Exception eException) {
			System.out.println("Exception in MappingSelector .."+eException.getMessage());
		}	
	}
		
	public void loadSelections() {
		try {
		//System.out.println(" in load selections().");
			//get the current directory path
			File fCurrentPath = new File(".");
			String strPath = new File(fCurrentPath.getCanonicalPath()).getParent(); 
			strPath += "/selections";
			
			File fSelections = new File(strPath);
			
			if (fSelections.isDirectory()) {	
				String strFiles[] = fSelections.list();
				//System.out.println("Number of files in input file directory "+strFiles.length);
				int intSno = 0;
									
				 for (int intLength = 0; intLength < strFiles.length; intLength++) {
				
					File fTmp = new File(strFiles[intLength]);
					
					String strFileName = strPath+"/"+fTmp.getName();
					//System.out.println(" <<<<<<<<<<< strInputFileName "+strInputFileName);
					if (strFileName != null)  {
						if((strFileName.endsWith("xml")) || (strFileName.endsWith("XML"))) {
							intSno++;
							//System.out.println("file name is "+strFileName);
							Object[] vecAvailableSelections = {(new Integer(intSno)).toString(),strFileName,""};
							jtLoadSelection.getColumn("Select").setCellRenderer(new ButtonRenderer());
							jtLoadSelection.getColumn("Select").setCellEditor(new ButtonEditor(new JCheckBox()));
							dmLoadSelection.addRow(vecAvailableSelections);
						}
					}
				}
				btnCancel.requestFocusInWindow();
			}
			
									
		}catch (IOException eIOException) {
			System.out.println(" MappingSelector .. IOException is "+eIOException.getMessage());
		}
	}
	
	public void actionPerformed(ActionEvent ae) {
		if (ae.getSource() == btnApplySelection) {
			try {
				ArrayList alCurveInfoList = new ArrayList();
				//System.out.println(" Clicked Apply Selection");
				int intMappingSelected = jtLoadSelection.getSelectedRow();
				if (intMappingSelected != -1) {
					strSelectionFile = (String) jtLoadSelection.getValueAt(intMappingSelected,1);
					//System.out.println(" before MAPPING_FILE_SELECTED "+strSelectionFile);
					
					//added code to set the selectionFile.
					String strSelectionName = strSelectionFile.substring(strSelectionFile.lastIndexOf("/")+1,(strSelectionFile.length()-4));
					objLasWitsml.objLasDataFile.setSelectionFile(strSelectionName);	
					//System.out.println("MAPPING_FILE_SELECTED "+strSelectionName);
					
					
					//Obtain a new instance of a DocumentBuilderFactory
					DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
					
					//Creates a new instance of a DocumentBuilder using the currently configured parameters.
					DocumentBuilder builder = factory.newDocumentBuilder();
					
					//Parse the content of the given URI as an XML document and return a new DOM Document object
					Document selectedDocument = builder.parse(strSelectionFile);
					//System.out.println(" selected document "+selectedDocument);
					
					//search for selected curves in selected .xml
					String strCurveInfoPath = "//las2witsml/selections/logCurveInfo[@selected='Y']";
					
					// Get LogCurveInfo List
					Element elRoot = selectedDocument.getDocumentElement();
					NodeList nlLogCurveInfo = XPathAPI.selectNodeList(selectedDocument, strCurveInfoPath, elRoot);
					//System.out.println(" Number of Curves selected  .."+nlLogCurveInfo.getLength());
					
					//get selected curves
					if ((nlLogCurveInfo != null) && (nlLogCurveInfo.getLength() > 0)) {
						// Process the curves in the curve list
						for (int intCurve = 0; intCurve < nlLogCurveInfo.getLength(); intCurve++) {
							Element elLogCurveInfo = (Element) nlLogCurveInfo.item(intCurve);
							//System.out.println("ndLogCurveInfo node name"+elLogCurveInfo.getTagName());
							
							//get the Mnemonic name 					
							String strMnemonic = elLogCurveInfo.getAttributeNode("mnemonic").getValue();
							//System.out.println(" SELECTED MNEMONIC IS .."+strMnemonic);
							
							if (strMnemonic != null) {
								alCurveInfoList.add(strMnemonic);
							}
						}
							
					} //end for nlLogCurveInfo.getLength
					//System.out.println(" LOAD SELECTIONS CURVE SIZE .."+alCurveInfoList.size());
				
					//Read curve data section
					ArrayList alCurveDefns = objLasWitsml.objLasDataFile.getLasData().getLogDefns();
					if ((alCurveDefns != null) && (alCurveDefns.size() > 0)) {
						for (int intCurveDefn = 0; intCurveDefn < alCurveDefns.size(); intCurveDefn++) {
							LasSectionInfo objLasSectionInfo = (LasSectionInfo) alCurveDefns.get(intCurveDefn);
							
							if (alCurveInfoList.contains(objLasSectionInfo.getMnemonic())) {
								objLasSectionInfo.setIsSelected(new Boolean(true));
							} else {
								objLasSectionInfo.setIsSelected(new Boolean(false));
							}
							alCurveDefns.set(intCurveDefn, objLasSectionInfo);
						} 
					}
										
					dispose();
					String strMandCurveData = "->Curve Data";
					objLasWitsml.MAND_DATA_SELECTED  = strMandCurveData;
					objLasWitsml.ParameterDetails();
					objLasWitsml.jlMandData.setSelectedIndex(1);
				} //end intMappingSelected != -1
				else {
				JOptionPane.showMessageDialog(null, "Please select a selection file ", "Load Selection", JOptionPane.ERROR_MESSAGE); 
				}				
			} catch (javax.xml.parsers.ParserConfigurationException eParserConfigurationException) {
				System.out.println("Error loading selections .ParserConfigurationException .."+eParserConfigurationException.getMessage());
			} catch (org.xml.sax.SAXException eSAXException) {
				System.out.println("Error loading selections .SAXException.."+eSAXException.getMessage());
			} catch (javax.xml.transform.TransformerException eTransformerException) {
				System.out.println("Error loading selections .TransformerException.."+eTransformerException);
			} catch (Exception eException) {
				System.out.println("Error loading selections ..."+eException.getMessage());
			}
		} else if (ae.getSource() == btnCancel) {
			System.out.println(" Clicked Cancel button");
			dispose();
		}
	}
} 